<html lang="en" xmns:th="http://www.thymeleaf.org" xmlns:layout="http://ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{fragments/layout}">

<head>
	<title>Page Variant API</title>
</head>

<body>
	<div layout:fragment="content">
		<h1>VARIANT API</h1>
		<br>
		<div class="container">
			<div class="row">
				<div class="col-sm"></div>
				<div class="col-sm">
					<table>
			    	<tr>
				    	<td>
					    	<button type="button" class="btn btn-primary" onclick="openModal()" >
							  Create New</button>
				    	</td>
				    	<td style='width:108px;'></td>
				    	<td><input onkeyup="searchVariant()" id="keySearch" type = 'text' placeholder="Search" value = '' ></td>
			    	</tr>
			    	</table><br>
					<dev id="isidata"></dev>
				</div>
				<div class="col-sm"></div>
			</div>
		</div>
		<script>
			$(function () {
				getAllVariant();
			})
			
			function searchVariant(){
				var key = $('#keySearch').val();
				
				if(key != 0 ){
					$.ajax({
						url: '/api/variant/search/'+key+'',
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							var str = "<table border = '2' class='table' style='text-align:center;'>"
							str += "<thead>"
							str += "<tr>"
							str += "<th>Category</th>"
							str += "<th>Initial</th>"
							str += "<th>Name</th>"
							str += "<th>Active</th>"
							str += "<th colspan='2'>Action</th>"
							str += "</tr>"
							str += "</thead>"
							str += "<tbody>"
							for (var i = 0; i < data.length; i++) {
								str += "<tr>"
								str += "<td>" + data[i].category.categoryName + "</td>"
								str += "<td>" + data[i].variantInitial + "</td>"
								str += "<td>" + data[i].variantName + "</td>"
								str += "<td><input type='checkbox' name='isactive' checked disabled></td>"
								str += "<td><button onclick='modalEdit("+data[i].id+")' >Edit</button></td>"
								str += "<td><button  onclick='modalDelete("+data[i].id+")' >Hapus</button></td>"
								str += "</tr>"
							}
							str += "</tbody>"
							str += "</table>"
							$('#isidata').html(str)
						}
					})
				}else{
					getAllVariant() 
				}
			}
			
			function getAllVariant() {
				$.ajax({
					url: '/api/variant',
					type: 'get',
					contentType: 'aplication/json',
					success: function (data) {
						var str = "<table border = '2' class='table' style='text-align:center;'>"
						str += "<thead>"
						str += "<tr>"
						str += "<th>Category</th>"
						str += "<th>Initial</th>"
						str += "<th>Name</th>"
						str += "<th>Active</th>"
						str += "<th colspan='2'>Action</th>"
						str += "</tr>"
						str += "</thead>"
						str += "<tbody>"
						for (var i = 0; i < data.length; i++) {
							str += "<tr>"
							str += "<td>" + data[i].category.categoryName + "</td>"
							str += "<td>" + data[i].variantInitial + "</td>"
							str += "<td>" + data[i].variantName + "</td>"
							str += "<td><input type='checkbox' name='isactive' checked disabled></td>"
							str += "<td><button onclick='modalEdit("+data[i].id+")' >Edit</button></td>"
							str += "<td><button  onclick='modalDelete("+data[i].id+")' >Hapus</button></td>"
							str += "</tr>"
						}
						str += "</tbody>"
						str += "</table>"
						$('#isidata').html(str)
					}
				})
			}

			function openModal() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'aplication/json',
					success: function (data) {
						var str = "<form'>"
							str += "<input id='variantId' type='hidden' value=0>"
							str += "<div class = 'form-group'>"
							str += "<label>Category</label>"
							str += "<select class = 'form-control' id = 'idCategory'>"
							for (var i = 0; i < data.length; i++) {
								str += "<option value='" + data[i].id + "'>" + data[i].categoryName + "</option>"
							}
							str += "</select>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Initial Variant</label>"
							str += "<input class = 'form-control' type='text' id = 'variantInitial'>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Name Variant</label>"
							str += "<input class = 'form-control' type='text' id = 'variantName'>"
							str += "</div>"
							str += "<div class = 'form-group form-check'>"
							str += "<input type = 'checkbox' class='form-check-input' id='isActive'>"
							str += "<label>Active</label>"
							str += "</div>"
							str += "</form>"
						
						$('#btn-save').html('Create Data').off('click').on('click',saveVariant)
						$('.modal-title').html('New Variant')
						$('.modal-body').html(str)
						$('#modal').modal('show')
					}
				})
			}
			
			function saveVariant(){
				
				var id = $('#variantId').val()
				var idCategory = $('#idCategory').val()
				var initial = $('#variantInitial').val()
				var name = $('#variantName').val()
				var active = $('#isActive')[0].checked 
				var link = ''
				var type = ''
				if(id==0){
					link = '/api/variant/add'
					type = 'post'
				}else{
					link = '/api/edit/variant/'+id+''
					type = 'put'
				}
				
				var formdata = '{'
					formdata += '"variantInitial":"'+initial+'",'
					formdata += '"variantName":"'+name+'",'
					formdata += '"isActive":'+active+','
					formdata += '"categoryId":'+idCategory+''
					formdata += '}'
					
				$.ajax({
					url: link,
					type: type,
					contentType:'application/json',
					data: formdata,
					success: function(){
						$('#modal').modal('toggle')
						getAllVariant()
					}
				})
			}
			
			function modalEdit(id){
				openModal();
				$.ajax({
					url:'/api/variant/'+id+'',
					type: 'get',
					contentType:'aplication/json',
					success: function (data){
						$('#variantId').val(data.id)
						$('#idCategory').val(data.categoryId)
						$('#variantInitial').val(data.variantInitial)
						$('#variantName').val(data.variantName)
						$('#isActive').prop("checked",true)
						$('#btn-save').html("Update Data")
						$('.modal-title').html("Variant Edit Form")
					}
				})
			}
			function modalDelete(id) {
				$.ajax({
					url: '/api/variant/'+id+'',
					type: 'get',
					contentType: 'aplication/json',
					success: function (data){
						var str = "<form>"
							str +="<table>"
							str += "<input value='"+data.id+"' type='hidden' class = 'form-control' id='variantId'>"
							str += "<tr>"
							str += "<td style='text-align:end'>Variant Initial  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td> "+data.variantInitial+"</td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td style='text-align:right'>Variant Name  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td> "+data.variantName+"</td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td style='text-align:end'>Active  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td><input disabled checked type='checkbox'  id='isActive'></td>"
							str += "</tr>"
							str += "</table>"
							str += "</form>"
						
						$('#btn-save').html('Delete')
						$('.modal-title').html('Delete Variant')
						$('.modal-body').html(str)
						$('.modal-body').css("margin","auto")
						$('#btn-save').off('click').on('click',deletedata)
						$('#modal').modal('show')
					}
				})
			}
			
			function deletedata(){
				var id = $('#variantId').val()
				$.ajax({
					url: '/api/delete/variant/'+id+'',
					type: 'put',
					contentType:'application/json',
					success: function(){
						$('#modal').modal('toggle')
						getAllVariant()
					}					
				})
			}
		</script>
	</div>
</body>

</html>